#include "mythread.h"

Thread::Thread()
{
   state = 0;
   leThread = 0;
}

Thread::~Thread()
{
   if(state == 1)
      pthread_cancel(leThread);
   pthread_detach(leThread);
}

pthread_t* Thread::start()
{
   if(!pthread_create(&(this->leThread), NULL, Thread::execute,  static_cast<void *>(this)))
   {
      state = 1;
      return &(this->leThread);
   }
   else
   {
      state = 0;
      return NULL;
   }
}

void* Thread::execute(void* thread)
{
   static_cast<Thread *>(thread)->run();
   
   pthread_exit(0);
}

void Thread::join()
{
   void *value = 0;
   
   pthread_join(leThread, &value);
}

void Thread::exit()
{
   pthread_exit(NULL);
}

bool Thread::isRunning(void) const
{
    if(state == 0)
        return false;

    return (leThread != 0) ? true : false;
}

void Thread::sleep(mseconds_t timeout_ms)
{
    usleep(timeout_ms * 1000);
}


MyThread::MyThread():Thread()
{
   stopped = false;
}

MyThread::~MyThread()
{
}

void MyThread::run() 
{
   char c1 = '#';

   stopped = false;
   cout << "\n";
   for(int i=1;(i<=100 && !stopped);i++)
   {
      write(1, &c1, 1);
      Thread::sleep(100); // 100 ms
   }
   cout << "\n";
   exit();
}

void MyThread::stop() 
{
   if(isRunning())
      stopped = true;   
}
