#ifndef MYTHREAD_H
#define MYTHREAD_H

#include <pthread.h>
#include <iostream>

using namespace std;

typedef unsigned long   mseconds_t;

class Thread
{
   private:
      pthread_t leThread;
      int state;
          
   public:
      Thread();
      ~Thread();
      
      pthread_t* start();
      static void* execute(void* thread);
      void join();
      void exit();
      virtual void run() = 0;
      bool isRunning(void) const;
      static void sleep(mseconds_t timeout_ms);
};

class MyThread : public Thread
{
   private:
      bool stopped;
      
   public:
      MyThread();
      ~MyThread();
      
      void run();
      void stop();
};

#endif
