#include <QtGui>

#include "mydialog.h"

MyDialog::MyDialog( QWidget *parent ) : QDialog( parent )
{
   progressBar = new QProgressBar(this);
   progressBar->setMaximum(100);
   progressBar->setValue(0);

   bSimuler   = new QPushButton(QString::fromUtf8("Simuler"), this);
   bArreter = new QPushButton(QString::fromUtf8("Arrêter"), this);
   bQuitter   = new QPushButton("Quitter", this);  
   connect(bSimuler, SIGNAL(clicked()), this, SLOT(simuler()));
   connect(bArreter, SIGNAL(clicked()), this, SLOT(arreter()));
   connect(bQuitter, SIGNAL(clicked()), this, SLOT(close()));
   
   QVBoxLayout *vLayout1 = new QVBoxLayout;
   QHBoxLayout *hLayout1 = new QHBoxLayout;
   QVBoxLayout *mainLayout = new QVBoxLayout;
   vLayout1->addWidget(progressBar);
   hLayout1->addWidget(bSimuler);
   hLayout1->addWidget(bArreter);
   hLayout1->addWidget(bQuitter);
   mainLayout->addLayout(vLayout1);
   mainLayout->addLayout(hLayout1);
   setLayout(mainLayout);

   setWindowTitle(QString::fromUtf8("Exemple avec thread"));
   setFixedHeight(sizeHint().height());

   myThread = new MyThread;
   connect(myThread, SIGNAL(newStep(int)), this, SLOT(perform(int)));
}

void MyDialog::simuler()
{
   if (!myThread->isRunning())
   {
      myThread->start();
   }
}

void MyDialog::arreter()
{
   if (myThread->isRunning())
   {
      myThread->terminate();
      myThread->wait();
   }
   progressBar->setValue(0);
}

void MyDialog::perform(int steps)
{
   if(steps <= progressBar->maximum())
      progressBar->setValue(steps);
}