#include <QtGui>

#include "mydialog.h"

MyDialog::MyDialog( QWidget *parent ) : QDialog( parent )
{
   steps = 0;
   progressBar = new QProgressBar(this);
   progressBar->setMaximum(100);   
   progressBar->setValue(steps);

   bSimuler   = new QPushButton(QString::fromUtf8("Simuler"), this);
   bArreter = new QPushButton(QString::fromUtf8("Arrêter"), this);
   bQuitter   = new QPushButton("Quitter", this);  
   connect(bSimuler, SIGNAL(clicked()), this, SLOT(simuler()));
   connect(bArreter, SIGNAL(clicked()), this, SLOT(arreter()));
   connect(bQuitter, SIGNAL(clicked()), this, SLOT(close()));
   
   QVBoxLayout *vLayout1 = new QVBoxLayout;
   QHBoxLayout *hLayout1 = new QHBoxLayout;
   QVBoxLayout *mainLayout = new QVBoxLayout;
   vLayout1->addWidget(progressBar);
   hLayout1->addWidget(bSimuler);
   hLayout1->addWidget(bArreter);
   hLayout1->addWidget(bQuitter);
   mainLayout->addLayout(vLayout1);
   mainLayout->addLayout(hLayout1);
   setLayout(mainLayout);

   setWindowTitle(QString::fromUtf8("Exemple sans thread"));
   setFixedHeight(sizeHint().height());
}

void MyDialog::simuler()
{
   steps = 0;
   while(steps < progressBar->maximum())
   {
      steps++;
      perform(steps);
      GoToSleep::msleep(250); // ou :
      //for(unsigned int i=0; i < 42500000; i++);
   }
}

void MyDialog::arreter()
{
   steps = 0;
   progressBar->setValue(steps);
}

void MyDialog::perform(int steps)
{
   if(steps <= progressBar->maximum())
      progressBar->setValue(steps);
}
